@ECHO off
REM Installation for MC interim fix
REM RenLei 07-01-26
REM you have to set the following variable
REM according to your system

CLS
SET SILENT=false
IF "%1a"=="a" GOTO no_param
IF NOT EXIST %1\License\TMV610 ECHO ****** Could not find directory %1\License\TMV610 ******
IF NOT EXIST %1\License\TMV610 GOTO no_param
SET ITM_HOME=%1
IF NOT "%2a"=="a" SET SILENT=true
GOTO genUninstall

:genUninstall
SET uninst=patch_uninstall.bat
SET missed=no
IF EXIST %uninst% DEL %uninst%
IF EXIST backup RD /s /q backup
MD backup
ECHO Backup old files first
IF NOT "%SILENT%"=="true" PAUSE
@XCOPY /E /I CNB backup\CNB
@XCOPY /E /I CNP backup\CNP
@XCOPY /E /I CNPS backup\CNPS
@XCOPY /E /I CMS backup\CMS
@XCOPY /E /I TMAITM6 backup\TMAITM6
@XCOPY /E /I InstallITM backup\InstallITM
FOR /F %%i IN (file_list.txt) DO ( IF EXIST %ITM_HOME%\%%i ( @XCOPY /Y %ITM_HOME%\%%i backup\%%i ) ELSE ( SET missed=yes ) )

ECHO Generate uninstall
IF NOT "%SILENT%"=="true" PAUSE
ECHO rem This is generated by patch_install.bat > %uninst%
ECHO rem This batch file could retore your original modules from an interim fix installation >> %uninst%
ECHO rem Please do not modify this file >> %uninst%
FOR /F %%i IN (file_list.txt) DO ( IF EXIST %ITM_HOME%\%%i ( ECHO XCOPY /Y backup\%%i %ITM_HOME%\%%i >> %uninst% ) )

SET dependency=
SETLOCAL EnableDelayedExpansion
FOR /F %%i IN (new_files.txt) DO (
	IF NOT "%%i"=="--" (
		IF "!dependency!"=="" (
			IF EXIST %ITM_HOME%\%%i (
				SET dependency=yes
			) ELSE (
				SET dependency=no
			)
		) ELSE (
			IF NOT EXIST %ITM_HOME%\%%i (
				ECHO DEL /Q %ITM_HOME%\%%i >> %uninst%
			)
			SET dependency=
		)
	)
)
ENDLOCAL
GOTO startInst


:startInst
CLS
set i=
ECHO Will install the interim fix to the directory %ITM_HOME%
ECHO If you don't want that, or if this is not correct, press CTRL-BREAK now,
IF NOT "%SILENT%"=="true" PAUSE
ECHO installing ...
FOR /F %%i IN (file_list.txt) DO ( IF EXIST %ITM_HOME%\%%i ( @xcopy /Y %%i %ITM_HOME%\%%i ) ELSE ( SET missed=yes ) )

SET dependency=
SETLOCAL EnableDelayedExpansion
FOR /F %%i IN (new_files.txt) DO (
	IF NOT "%%i"=="--" (
		IF "!dependency!"=="" (
			IF EXIST %ITM_HOME%\%%i (
				SET dependency=yes
			) ELSE (
				SET dependency=no
			)
		) ELSE (
			IF "!dependency!"=="yes" (
				ECHO %%i
				@COPY /Y %%i %ITM_HOME%\%%i 
				SET dependency=
			)
		)
	)
)
ENDLOCAL
goto result

:result
set i=
echo *************************************************************
echo *************************************************************
IF %missed%==yes ECHO Below file(s) were not copied during this installation.
IF %missed%==yes ECHO Because they do not exist in your directory, probably you did not install the related component, it is normal
IF %missed%==yes ( For /F %%i IN (file_list.txt) DO ( IF NOT EXIST %ITM_HOME%\%%i ECHO %%i ) )
IF %missed%==yes ECHO *************************************************************
IF %missed%==yes ECHO *************************************************************
ECHO Install complete
goto endpro

:no_param
ECHO You did not specify your ITM installation path
ECHO Try the standard folder first - C:\IBM\ITM -
PAUSE
SET ITM_HOME=C:\IBM\ITM
IF not EXIST %ITM_HOME%\License\TMV610 (
	ECHO Could not find directory %ITM_HOME%\License\TMV610
	PAUSE
)
IF not EXIST %ITM_HOME% GOTO queryITM
goto genUninstall

:queryITM
ECHO Please input your ITM folder:
SET /P ITM_HOME=
IF not EXIST %ITM_HOME%\License\TMV610 ( ECHO Could not find directory %ITM_HOME%\License\TMV610 ) ELSE GOTO genUninstall
IF not EXIST %ITM_HOME%\License\TMV610 GOTO queryITM

:endpro
